
package fi.helsinki.cs.koskelo.common;

/** TTK91 tehtvien parsimiseen kytettvi yhteisi metodeja */

public class TTK91ParserUtils { 

	/** Tarkistaa onko annettu String mritelty TTK91-konekielen
	 * kskyksi. Jos TTK-91 kieleen mritelln uusia kskyj
	 * syksyn 2004 jlkeen, on ne ksin listtv thn luokkaan
	 * tai muutettava tm metodi, jotta automaattinen tehtvien
	 * tarkistus ja luonti edelleen toimii.
	 * @param command TTK-91 kskyn String-esitys
	 * @return Onko annettu ksky validi TTK-91 ksky
	 */

	static public boolean validateTTK91Command(String command) {

		if( 
				command.equalsIgnoreCase("LOAD") || 
				command.equalsIgnoreCase("STORE") ||
				command.equalsIgnoreCase("IN") ||
				command.equalsIgnoreCase("OUT") ||
				command.equalsIgnoreCase("ADD") ||
				command.equalsIgnoreCase("SUB") ||
				command.equalsIgnoreCase("MUL") ||
				command.equalsIgnoreCase("DIV") ||
				command.equalsIgnoreCase("MOD") ||
				command.equalsIgnoreCase("AND") ||
				command.equalsIgnoreCase("OR")  ||
				command.equalsIgnoreCase("XOR") ||
				command.equalsIgnoreCase("SHL") ||
				command.equalsIgnoreCase("SHR") ||
				command.equalsIgnoreCase("COMP") ||
				command.equalsIgnoreCase("JUMP") ||
				command.equalsIgnoreCase("JNEG") ||
				command.equalsIgnoreCase("JZER") ||
				command.equalsIgnoreCase("JPOS") ||
				command.equalsIgnoreCase("JNNEG") ||
				command.equalsIgnoreCase("JNZER") ||
				command.equalsIgnoreCase("JNPOS") ||
				command.equalsIgnoreCase("JEQU") ||
				command.equalsIgnoreCase("JGRE") ||
				command.equalsIgnoreCase("JLES") ||
				command.equalsIgnoreCase("JNLES") ||
				command.equalsIgnoreCase("JNEQU") ||
				command.equalsIgnoreCase("JNGRE") ||
				command.equalsIgnoreCase("PUSH") ||
				command.equalsIgnoreCase("POP") ||
				command.equalsIgnoreCase("CALL") ||
				command.equalsIgnoreCase("EXIT") ||
				command.equalsIgnoreCase("SVC") ||
				command.equalsIgnoreCase("NOP") ||
				command.equalsIgnoreCase("NOT") ||
				command.equalsIgnoreCase("SHRA") ||
				command.equalsIgnoreCase("DC") ||
				command.equalsIgnoreCase("DS") ||
				command.equalsIgnoreCase("EQU")
				
				) {
				
					return true;
				
				} else {
				
					return false;
				
				}
	
	}
}
