package fi.helsinki.cs.koskelo.common;

import java.util.Vector;

/**
 * Kreluokka tehtvtiedoille
 * @author Lauri Liuhto
 */
public class TTK91TaskOptions {

    //	public final static int COMPARE_TO_SIMULATED = 0; // FIXME syntaxCheckeriin nm kanssa kyttn ja kai jsp-sivuille?
    //	public final static int COMPARE_TO_STATIC = 1;
  //  private final static int MAX_COMMANDS = 10000; // obsolete
	
  					 //[EN] ei, mutta
						 //jos verkkosivuilla jtt
						 //kentn tyhjksi asettaa
						 //syntaxChecker saman arvon --> FIXME -> TTK91Constant.MAX_COMMANDS
    
  private Vector regcrits;
  private Vector memcrits;
  private Vector screencrits;
  private Vector filecrits;

  private String examplecode;
  private String taskdescription;

  private int[] publicinput;
  private int[] hiddeninput;

  private TTK91TaskCriteria[] screenoutput;
  private TTK91TaskCriteria[] fileoutput;
  
  private int comparemethod;
  private int maxcommands;
  private int acceptedsize;
  private int optimalsize;
  private TTK91TaskCriteria memrefcriteria;

  private String[] reqcmds;
  private String[] forbiddencmds;

  private TTK91TaskFeedback taskfeedback;

  /**
   * Konstruktori
   */

  public TTK91TaskOptions() {
    this.regcrits = new Vector();
    this.memcrits = new Vector();
    this.screencrits = new Vector();
    this.filecrits = new Vector();
    this.examplecode = null;
    this.taskdescription = null;
    this.publicinput = null;
    this.hiddeninput = null;
    this.screenoutput = null;
    this.fileoutput = null;
    this.comparemethod = 0;
    this.maxcommands = TTK91Constant.MAX_COMMANDS;
    this.acceptedsize = 0;
    this.optimalsize = 0;
    this.memrefcriteria = null;
    this.reqcmds = null;
    this.forbiddencmds = null;
    this.taskfeedback = null;
  }

  /**
   * Yksityinen apumetodi kriteereiden lismiseen 
   * @param crit taulukko, jonka sislt listn viitteen saatuun silin
   * @param critcollection viite silin, johon kriteerit tallennetaan
   */
  private static void addCriterias(TTK91TaskCriteria crit[], Vector critcollection) {
    if (crit != null) {
	    for (int i=0; i<crit.length; ++i) {
        critcollection.add(crit[i]);
	    }
    }
  }

  /**
   * Lis rekisterin kriteerit kokoelmaan.
   * @param crit Kokoelmaan listtv kriteeritaulukko
   */
  public void setRegisterCriterias(TTK91TaskCriteria[] crit) {
    this.regcrits = new Vector();
    TTK91TaskOptions.addCriterias(crit, this.regcrits);
  } // addRegisterCriteria(TTK91TaskCriteria[] crit)
  
  
  /**
   * Lis rekisterikriteerin kokoelman viimeiseksi.
   * @param crit Kokoelmaan listtv kriteeri
   */
  public void addRegisterCriteria(TTK91TaskCriteria crit) {
    if (crit != null) {
	    this.regcrits.add(crit);
    }
  } // addRegisterCriteria


  /**
   * Lis muistipaikka- tai muuttujakriteerit kokoelmaan.
   * @param crit Kokoelmaan listtv kriteeritaulukko
   */
  public void setMemoryCriterias(TTK91TaskCriteria[] crit) {
    this.memcrits = new Vector();
    TTK91TaskOptions.addCriterias(crit, this.memcrits);
  } // addMemoryCriteria(TTK91TaskCriteria[] crit)


  /**
   * Lis muistipaikan tai muuttujan kriteerin muisti-taulukon viimeiseksi.
   * @param crit Kokoelmaan listtv kriteeri
   */
  public void addMemoryCriteria(TTK91TaskCriteria crit) {
    if (crit != null) {
	    this.memcrits.add(crit);
    }
  } // addMemoryCriteria


  /**
   * Lis nytn tulosteeseen liittyvt kriteerit kokoelmaan.
   * @param crit Kokoelmaan listtv kriteeritaulukko
   */
  public void setScreenOutputCriterias(TTK91TaskCriteria[] crit) {
      this.screenoutput = crit;
  } // addScreenOutputCriteria(TTK91TaskCriteria[] crit)


  /**
   * Lis nytn tulosteeseen liittyvn kriteerin crt-taulukon viimeiseksi.
   * @param crit Kokoelmaan listtv kriteeri
   */
  
 /* public void addScreenOutputCriteria(TTK91TaskCriteria crit) {
    if (crit != null) {
	    this.screencrits.add(crit);
    }
  } // addScreenOutputCriteria
*/

  /**
   * Lis tiedostoon tulostamiseen liittyvt kriteerit kokoelmaan.
   * @param crit Kokoelmaan listtv kriteeritaulukko
   */
  public void setFileOutputCriterias(TTK91TaskCriteria[] crit) {
      this.fileoutput = crit;
  } // addFileOutputCriteria(TTK91TaskCriteria[] crit)


  /**
   * Lis tiedostoon tulostamiseen liittyvn kriteerin file-taulukon viimeiseksi.
   * @param crit Kokoelmaan listtv kriteeri
   */
  /*
  public void addFileOutputCriteria(TTK91TaskCriteria crit) {
    if (crit != null) {
	    this.filecrits.add(crit);
    }
  } // addFileOutputCriteria
*/

  /**
   * Asettaa mallivastauksen.
   * @param code Asetettava TTK91-kielinen mallivastaus merkkijonona
   */
  public void setExampleCode(String code) {
    this.examplecode = code;
  } // setExampleCode


  /**
   * Asettaa tehtvnannon.
   * @param description Asetettava tehtvnanto merkkijonona
   */
  public void setTaskDescription(String description) {
    this.taskdescription = description;
  } // setTaskDescription


  /**
   * Asettaa public-taulukkoon opiskelijalle nytettvt sytteet.
   * @param input Asetettavat julkiset sytteet
   */
  public void setPublicInput(int[] input) {
      if (input != null) {
	  for (int i=0; i<input.length; ++i) {
	      System.err.print(input[i]+" ");
	  }
      }
    this.publicinput = input;
  } // setPublicInput


  /**
   * Asettaa hidden-taulukkoon salaiset testisytteet.
   * @param input Asetettavat salaiset sytteet
   */
  public void setHiddenInput(int[] input) {
    this.hiddeninput = input;
  } // setHiddenInput


  /**
   * Asettaa arvon miten tehtvn oikeellisuus tutkitaan.
   * @param method //FIXME: selitys
   */
  public void setCompareMethod(int method) {
    this.comparemethod = method;
  } // setCompareMethod


  /**
   * Asettaa rajan suoritettavien komentojen mrlle.
   * @param value Suoritettavien TTK91-komentojen maksimimr
   */
  public void setMaxCommands(int value) {
    this.maxcommands = value;
  } // setMaxCommands


  /**
   * Asettaa hyvksymisrajan ohjelman koolle kskyiss mitattuna.
   * @param size TTK91-komentojen (hyvksyttv) maksimimr 
   */
  public void setAcceptedSize(int size) {
    this.acceptedsize = size;
  } // setAcceptedSize


  /**
   * Asettaa ohjelman ihannekoon kskyiss mitattuna.
   * @param size TTK91-komentojen ihannemr
   */
  public void setOptimalSize(int size) {
    this.optimalsize = size;
  } // setOptimalSize

  /**
   * Asettaa muistiviitteiden maaraan liityvan kriteerin
   * @param memrefs muistiviitekriteeri
   */
  public  void setMemRefCriteria(TTK91TaskCriteria memrefs) {
    this.memrefcriteria = memrefs;
  }

  /**
   * Asettaa ohjelmassa vaaditut komennot.
   * @param commands TTK91-ohjelmassa vaadittavat komennot
   */
  public void setRequiredCommands(String[] commands) {
    this.reqcmds = commands;
  } // setRequiredCommands

  
  /**
   * Asettaa ohjelmassa ehdottomasti kielletyt komennot.
   * @param commands TTK91-ohjelmassa kielletyt komennot
   */
  public void setForbiddenCommands(String[] commands) {
    this.forbiddencmds = commands;
  } // setForbiddenCommands


  /**
   * Asettaa palautetiedot
   * @param feedback Tehtvn palautetiedot // FIXME: kuvaus
   */
  public void setTaskFeedback(TTK91TaskFeedback feedback) {
    this.taskfeedback = feedback;
  }


  /**
   * Hakee kaikki rekistereihin liittyvt kriteerit.
   * @return rekisterikriteerit
   */
  public TTK91TaskCriteria[] getRegisterCriterias() {
    TTK91TaskCriteria[] ret = new TTK91TaskCriteria[regcrits.size()];
    for (int i = 0; i < ret.length; ++i) {
	    ret[i] = (TTK91TaskCriteria) regcrits.get(i);
    }
    return ret;
  } // getRegisterCriterias


  /**
   * Hakee muistipaikkojen kyttn liittyvt kriteerit.
   * @return muistipaikkakriteerit
   */
  public TTK91TaskCriteria[] getMemoryCriterias() {
    TTK91TaskCriteria[] ret = new TTK91TaskCriteria[memcrits.size()];
    for (int i = 0; i < ret.length; ++i) {
	    ret[i] = (TTK91TaskCriteria) memcrits.get(i);
    }
    return ret;
  } // getMemoryCriterias


  /**
   * Hakee kaikki nytn tulosteisiin liittyvt kriteerit.
   * @return kriteerit TTK91-simulaattorin nytttulosteille
   */
  public TTK91TaskCriteria[] getScreenOutputCriterias() {
    return this.screenoutput;
  } // getScreenOutputCriterias


  /**
   * Hakee kaikki tiedoston tulosteisiin liittyvt kriteerit.
   * @return kriteerit TTK91-simulaattorin tiedostotulosteille
   */
  public TTK91TaskCriteria[] getFileOutputCriterias() {
    return this.fileoutput;
  } // getFileOutputCriterias


 
  /**
   * Hakee mallivastauksen.
   * @return mallivastaus merkkijonona
   */
  public String getExampleCode() {
    return this.examplecode;
  } // getExampleCode


  /**
   * Hakee tehtvnannon.
   * @return tehtvnanto
   */
  public String getTaskDescription() {
    return this.taskdescription;
  } // getTaskDescription


  /**
   * Hakee opiskelijalle nytettvt sytteet.
   * @return opiskelijalle nytettvt sytteet
   */
  public int[] getPublicInput() {
    return this.publicinput;
  } // getPublicInput


  /**
   * Hakee salaiset testisytteet.
   * @return salaiset testisytteet
   */
  public int[] getHiddenInput() {
    return this.hiddeninput;
  } // getHiddenInput


  /**
   * Hakee vertailutavan jolla tehtv tarkastetaan. // FIXME: kuvaus
   * @return vertailutapa // FIXME: kuvaus
   */
  public int getCompareMethod() {
    return this.comparemethod;
  } // getCompareMethod


  /**
   * Hakee titokoneella suoritettavien kskyjen maksimilukumrn.
   * @return maksimissaan suoritettavien kskyjen mr
   */
  public int getMaxCommands() {
    return this.maxcommands;
  } // getMaxCommands


  /**
   * Hakee luvun joka ilmoittaa monta komentoa koodissa saa enintn esiinty.
   * @return hyvksyttv TTK91-koodin koko kskyin
   */
  public int getAcceptedSize() {
    return this.acceptedsize;
  } // getAcceptedSize


  /**
   * Hakee luvun joka ilmoittaa mik olisi ihannekoko ohjelmalle komentojen mrll mitattuna.
   * @return ihannekoko TTK91-koodille kskyin
   */
  public int getOptimalSize() {
    return this.optimalsize;
  } // getOptimalSize

  /**
   * Hakee muistiviitekriteerin
   * @return kytettyjen muistiviittausten mr tarkasteleva kriteeri
   */
  public TTK91TaskCriteria getMemRefCriteria() {
    return this.memrefcriteria;
  }

  /**
   * Hakee ratkaisussa vaaditut komennot.
   * @return vaaditut komennot
   */
  public String[] getRequiredCommands() {
    return this.reqcmds;
  } // getRequiredCommands


  /**
   * Hakee ratkaisussa kielletyt komennot.
   * @return kielletyt komennot
   */
  public String[] getForbiddenCommands() {
    return this.forbiddencmds;
  } // getForbiddenCommands


  /**
   * Hakee ja palauttaa palautetiedot
   * @return palautetiedot
   */
  public TTK91TaskFeedback getTaskFeedback() {
    return this.taskfeedback;
  }
  
} // public class TTK91TaskOptions
