/**
 * Luokka, joka huolehtii staattisten tehtvien
 * html-koodin tuottamisesta.
 * @author Tom Bertell, Koskelo-projekti
 */

package fi.helsinki.cs.koskelo.displayer;

import fi.hy.eassari.showtask.trainer.CacheException;

public class StaticTTK91Displayer extends CommonDisplayer {

	/**
	 * Konstruktori, joka kutsuu ylluokan CommonAnalyser
	 * konstruktoria.
	 */

	public StaticTTK91Displayer() {
		super();
	}//StaticTTK91Displayer 
    
	final int COLS = 50;    // vastauslaatikon leveys
	final int ROWS = 20;    // vastauslaatiokon korkeus
	final String TARGETSERVLET = "Answer2.do2"; // kohdeservletin nimi 

	/**
	 * Tekee tehtvn tiedoista html-koodia ja palauttaa 
	 * html-koodin String-oliona. Kutsutaan DisplayerServlet2- ja
	 * Answer2-servleteist.
	 *
	 * @param  initval tehtvn vastaus
	 * @param  params  generoidut parametrit
	 * @param  hiddens lomakkeen piilokentt String-oliona.
	 * @param  allowTry kertoo tuleeko sivun loppuun vastauspainike  
	 * @return tehtvn esitys html-muodossa
	 * @throws CacheException jos tulee ongelmia attribuuttien 
	 *                        hakemisessa AttributeCachesta
	 */

	public String getSetting(String [] initVal, 
													 String params, 
													 String hiddens,  
													 boolean allowTry) throws CacheException {

		String taskDescription; // tehtvnanto
		String input;           // sytteet
		String inputHeader;     // sytteen otsikko
    StringBuffer setting = new StringBuffer(); // kertn palautettava sivu

		/*
		 * Listn piilokentt tehtvntyypille
		 */

		hiddens += ("<input type=\"hidden\" name=\"tasktype\"" 
								+"value=\"staticttk91task\">");

		/*
		 * Haetaan tehtvnanto, sytteet ja sytteen otsikko.
		 */

		taskDescription = 
			cache.getAttribute("T", taskid, "taskDescription", language);
		if (taskDescription == null || taskDescription.equals("null"))
			taskDescription = "";
		input = 
			cache.getAttribute("T", taskid, "publicInput", language);
		if (input == null || input.equals("null"))
			input = "";
		inputHeader = 
			cache.getAttribute("D", "staticttk91taskdisplayer", 
												 "inputHeader", language);
		
		/*
		 * Lomake alkaa
		 */

		setting.append("<form action=" + TARGETSERVLET + 
									 " method=\"post\" name=\"staticttk91task\"" +
									 "id=\"staticttk91task\">");
	
    /*   
		 * Listn tehtvnanto ja sytteet
		 */

		setting.append(TTK91DisplayerUtils.getHTMLElementTask(taskDescription));
		setting.append(TTK91DisplayerUtils.getHTMLElementInput(inputHeader, 
																													 input));

		/* 
		 * Listn vastauslaatikko. Jos parametri initVal on null,
		 * luodann tyhj tehtvlaatikko, muutoin opiskelijan vastaus 
		 * laitetaan laatikkoon.
		 */

		if (initVal == null) {
			setting.append(TTK91DisplayerUtils.getHTMLElementAnswerBox(ROWS, COLS));
		} else {
			setting.append(TTK91DisplayerUtils.getHTMLElementAnswerBox(initVal,
																																 ROWS, COLS));
		}
		/*
		 * Listn analyserin tarvitsemat piilokentt lomakkeeseen
		 */

		setting.append(hiddens);
		
		/*
		 * Jos tehtvn lhetys sallitaan, luodaan lhet-nappi
		 */

		if (allowTry) {
			setting.append(super.getButton());
		}
       
		/*
		 * Lomake loppuu
		 */

		setting.append("</form>");
		return new String(setting);

	}//getSetting

}//class
