/**
 * Luokka sislt TTK91Displayer-luokille yhteisi apumetodeita.
 * Ne palauttavat yhteisi html-elementtej.
 * @author Tom Bertell
 */

package fi.helsinki.cs.koskelo.displayer;

public class TTK91DisplayerUtils {

	/**
	 * Palauttaa tehtvnannon html-muodossa.
	 *
	 * @param  task tehtvnanto 
	 * @return tehtvnanto html-muodossa
	 */

	public static String getHTMLElementTask(String task){
	
		return new String("<p class=\"assignment\"><strong>" 
											+task +"</strong></p>");
	}//getHTMLElementTask

	/**
	 * Palauttaa sytteet html-muodossa.
	 *
	 * @param inputText kieliriippuvainen syteteksti esim. suomeksi sytteet 
	 *        -> englanniksi input jne.
	 * @param input varsinaiset sytteet                     
	 * @return sytteet html-muodossa
	 */

	public static String getHTMLElementInput(String inputHeader, String input){

		 if (input == null || input.equals("")) {
      return "";
    }else {
    return new String("<p class=\"input\"><strong>" 
		      +inputHeader +": " +input +"</strong></p>");
    }
	
	}//getHTMLELementInput
    
	/**
	 * Palauttaa tyhjn vastauslaatikon html-muodossa.
	 *
	 * @param  rows vastaslaatikon korkeus
	 * @param  cols vastauslaatikon leveys
	 * @return tyhj vastauslaatikko html-muodossa
	 */

	public static String getHTMLElementAnswerBox(int rows, int cols){
	
		return new String("<textarea name=\"answer\" cols=\"" +cols +"\"" + 
											" rows=\"" +rows +"\"></textarea><br>");
	}//getHTMLElementAnswerBox
      
	/**
	 * Palauttaa vastauslaatikon, joka sislt vastauksen
	 *
	 * @param  answer vastaus
	 * @param  rows vastaslaatikon korkeus
	 * @param  cols vastauslaatikon leveys
	 * @return tytetty vastauslaatikko html-muodossa
	 */
 
	public static String getHTMLElementAnswerBox(String[] answer, int rows, 
																							 int cols){
	
		StringBuffer answerbox = new StringBuffer();

		answerbox.append("<textarea name=\"answer\" cols=\"" +cols +"\""+ 
										 " rows=\"" +rows +"\">");

		answerbox.append(answer[0]);
		answerbox.append("</textarea><br>");
		return new String(answerbox);
	}//getHTMLElementAnswerBox

}//class
